package au.id.rupert.taxi_name_board;
// V20 Created for older small screen devices eg HTC Wildfire

//  Try to find a way to keep the menu from closing every time you press the enlarge button etc.

// http://www.eigo.co.uk/labs/lock-screen-orientation-in-android/
// http://www.androidhive.info/2011/09/how-to-create-android-menus/

// Capture the DONE key on entry of name and save prefs

import android.os.Bundle;
import android.app.Activity;
import android.content.Context;
import android.content.SharedPreferences;
import android.content.pm.ActivityInfo;
import android.util.TypedValue;
import android.view.KeyEvent;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.view.View.OnKeyListener;
import android.view.inputmethod.InputMethodManager;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.Toast;


public class MainActivity extends Activity {

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		
		// Initialise variables
		String strClientName = "";
		Float fltClientNameSize = 0.0f;
		Float fltClientNameScaleX = 0.0f;
		
		// set up SharedPreferences
	     String CLIENT_NAME_KEY = "clientName";
	     String CLIENT_NAME_SIZE_KEY = "clientNameSize";
   	     String CLIENT_NAME_SCALE_KEY = "clientNameScale";
	     String prefName = "MyPref";
	     
		//---load the SharedPreferences object---
		SharedPreferences prefs = getSharedPreferences(prefName, MODE_PRIVATE);
        
        // Read the saved preferences
        strClientName = prefs.getString(CLIENT_NAME_KEY, "Click here");
        fltClientNameScaleX = prefs.getFloat(CLIENT_NAME_SCALE_KEY, 1.2f);    
        fltClientNameSize = prefs.getFloat(CLIENT_NAME_SIZE_KEY, 90f);
        
        
        // Display the screen
		setContentView(R.layout.activity_main);
		 this.setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_LANDSCAPE);
		 	 
		 // Set the string in the editTextView to the saved preference
	    	final TextView textViewToChange = (TextView) findViewById(R.id.editText1);
	    	
	    	textViewToChange.setText(strClientName);
	
	    	Toast.makeText(getApplicationContext(), "Set Size: " + fltClientNameSize ,Toast.LENGTH_SHORT).show();
	 //  	Toast.makeText(getApplicationContext(), "fltClientNameScaleX: " + fltClientNameScaleX ,Toast.LENGTH_SHORT).show();
	   	 	
		    // Restore Values
	    	textViewToChange.setTextSize(TypedValue.COMPLEX_UNIT_PX, fltClientNameSize);
		   	textViewToChange.setTextScaleX(fltClientNameScaleX);
		   	textViewToChange.setText(strClientName);
	    
			// ***********
		    // Catching the done button	
		    EditText editText1 = (EditText) findViewById(R.id.editText1);
		    editText1.setOnKeyListener(new OnKeyListener() {

		        public boolean onKey(View v, int keyCode, KeyEvent event) {

		    	// set up SharedPreferences
		   	     String CLIENT_NAME_KEY = "clientName";
		   	     String prefName = "MyPref";
		   	     
		   	     // Toast.makeText(getApplicationContext(), "a Key was pressed", Toast.LENGTH_SHORT).show();
		   	   
		   	     switch(keyCode) {
		            case KeyEvent.KEYCODE_ENTER:
		            
		            // Done button pressed
		           
		            //---get the SharedPreferences object---
		            SharedPreferences prefs = getSharedPreferences(prefName, MODE_PRIVATE);
		        	SharedPreferences.Editor editor = prefs.edit();
		        	
					// Save values when the close button is pressed
		        	EditText strName1 = (EditText) findViewById(R.id.editText1);
		         
		            //---save the string to preferences---    
		            editor.putString(CLIENT_NAME_KEY, strName1.getText().toString());
		            editor.commit();       
		          
		            // Close the soft keyboard
		            // http://stackoverflow.com/questions/1109022/close-hide-the-android-soft-keyboard 
		            // Answer 18
			         
		            InputMethodManager imm = (InputMethodManager)getSystemService(
		            	      Context.INPUT_METHOD_SERVICE);
		            	imm.hideSoftInputFromWindow(strName1.getWindowToken(), 0);
		          break;
		      default:
		      return false;
		      }
		return true;
		}

		});
		//*** end of catching the done button
		}

	 // Initiating Menu XML file (menu.xml)
    @Override
    public boolean onCreateOptionsMenu(Menu menu)
    {
        MenuInflater menuInflater = getMenuInflater();
        menuInflater.inflate(R.layout.menu, menu);
        return true;
    }
	  
    /**
     * Event Handling for Individual menu item selected
     * Identify single menu item by it's id
     * */
    @Override
    public boolean onOptionsItemSelected(MenuItem item)
    {
    	TextView textViewToChange = (TextView) findViewById(R.id.editText1);
    	float TextSize = textViewToChange.getTextSize();
    	float textScaleX = textViewToChange.getTextScaleX();
	    
    	// set up SharedPreferences
    	 SharedPreferences prefs;
  	     String CLIENT_NAME_KEY = "clientName";
  	     String CLIENT_NAME_SIZE_KEY = "clientNameSize";
	     String CLIENT_NAME_SCALE_KEY = "clientNameScale";
  	     String prefName = "MyPref";
  	     
	    //---get the SharedPreferences object---
		prefs = getSharedPreferences(prefName, MODE_PRIVATE);
    	SharedPreferences.Editor editor = prefs.edit();
    	
		// Save values when the close button is pressed
        EditText clientName = (EditText) findViewById(R.id.editText1);
        
        switch (item.getItemId())
        {
        // LARGER ===================================================================================================   
        case R.id.menu_larger:
        	TextSize = textViewToChange.getTextSize();
        	TextSize = TextSize + 20;
        	textViewToChange.setTextSize(TypedValue.COMPLEX_UNIT_PX, TextSize);
        	
            //---save the values in the EditText view to preferences---
            editor.putString(CLIENT_NAME_KEY, clientName.getText().toString());
            editor.putFloat(CLIENT_NAME_SIZE_KEY,  clientName.getTextSize());
            editor.putFloat(CLIENT_NAME_SCALE_KEY, clientName.getTextScaleX());
            
            //---saves the values---
            // Toast.makeText(MainActivity.this, "Save Shared Preferences", Toast.LENGTH_SHORT).show();  
	    	Toast.makeText(getApplicationContext(), "Set Size: " + clientName.getTextSize() ,Toast.LENGTH_SHORT).show();
            editor.commit();  
         return true;
 
        // SMALLER ===================================================================================================   
        case R.id.menu_smaller:
        	  TextSize = textViewToChange.getTextSize();
         	  TextSize = TextSize - 20;
              textViewToChange.setTextSize(TypedValue.COMPLEX_UNIT_PX, TextSize);
              
              //---save the values in the EditText view to preferences---
              editor.putString(CLIENT_NAME_KEY, clientName.getText().toString());
              editor.putFloat(CLIENT_NAME_SIZE_KEY,  clientName.getTextSize());
              editor.putFloat(CLIENT_NAME_SCALE_KEY, clientName.getTextScaleX());
              
              //---saves the values---
              // Toast.makeText(MainActivity.this, "Save Shared Preferences", Toast.LENGTH_SHORT).show();  
  	          Toast.makeText(getApplicationContext(), "Set Size: " + clientName.getTextSize() ,Toast.LENGTH_SHORT).show();
              editor.commit();  
        return true;
    
        // STRETCH ===================================================================================================    
        case R.id.menu_stretch:
        	  textScaleX = (float) (textScaleX + 0.1) ;
        	  textViewToChange.setTextScaleX(textScaleX);
        	  
              //---save the values in the EditText view to preferences---
              editor.putString(CLIENT_NAME_KEY, clientName.getText().toString());
              editor.putFloat(CLIENT_NAME_SIZE_KEY,  clientName.getTextSize());
              editor.putFloat(CLIENT_NAME_SCALE_KEY, clientName.getTextScaleX());
              
              //---saves the values---
              // Toast.makeText(MainActivity.this, "Save Shared Preferences", Toast.LENGTH_SHORT).show();  
  	    	  Toast.makeText(getApplicationContext(), "Set Size: " + clientName.getTextSize() ,Toast.LENGTH_SHORT).show();
              editor.commit();  
        return true;
      
      // SHRINK ===================================================================================================     	
      case R.id.menu_shrink:
    	  	textScaleX = (float) (textScaleX - 0.1) ;
            textViewToChange.setTextScaleX(textScaleX);
            
            //---save the values in the EditText view to preferences---
            editor.putString(CLIENT_NAME_KEY, clientName.getText().toString());
            editor.putFloat(CLIENT_NAME_SIZE_KEY,  clientName.getTextSize());
            editor.putFloat(CLIENT_NAME_SCALE_KEY, clientName.getTextScaleX());
            
            //---saves the values---
            // Toast.makeText(MainActivity.this, "Save Shared Preferences", Toast.LENGTH_SHORT).show();  
	    	Toast.makeText(getApplicationContext(), "Set Size: " + clientName.getTextSize() ,Toast.LENGTH_SHORT).show();
            editor.commit();  
      return true;
        }
		return false;
    }    
    
   	// Catch the menu key
   	public boolean onKeyDown(int keyCode, KeyEvent event) { 
        if (keyCode == KeyEvent.KEYCODE_MENU) {
       	
	       // Toast.makeText(MainActivity.this, "Menu pressed", Toast.LENGTH_SHORT).show();  
	        boolean menuOpen = false;
	
	        if (menuOpen == false) {
	            menuOpen = true;
	            openOptionsMenu();
	        } else {
	            closeOptionsMenu();
	        }
	    return true;
        }
        
        if (keyCode == KeyEvent.KEYCODE_BACK ) {
   	        //Back key pressed
        	// Toast.makeText(MainActivity.this, "Back pressed", Toast.LENGTH_SHORT).show(); 
   	    
        	// set up SharedPreferences
        	 SharedPreferences prefs;
      	     String CLIENT_NAME_KEY = "clientName";
      	     String CLIENT_NAME_SIZE_KEY = "clientNameSize";
    	     String CLIENT_NAME_SCALE_KEY = "clientNameScale";
      	     String prefName = "MyPref";
      	     
    	    //---get the SharedPreferences object---
    		prefs = getSharedPreferences(prefName, MODE_PRIVATE);
        	SharedPreferences.Editor editor = prefs.edit();
        	
    		// Save values when the close button is pressed
            EditText clientName = (EditText) findViewById(R.id.editText1);
            
            //---save the values in the EditText view to preferences---
            editor.putString(CLIENT_NAME_KEY, clientName.getText().toString());
            editor.putFloat(CLIENT_NAME_SIZE_KEY,  clientName.getTextSize());
            editor.putFloat(CLIENT_NAME_SCALE_KEY, clientName.getTextScaleX());
            
            //---saves the values---
            Toast.makeText(MainActivity.this, "Save Shared Preferences", Toast.LENGTH_SHORT).show();  
            editor.commit();  
        	finish();
   	    }
        return super.onKeyDown(keyCode, event); 
   	} 

}


